Eclipse Rich Ajax Platform

## org.eclipse.swt.events
Class KeyEvent

    java.lang.Object
      Event
          org.eclipse.swt.events.TypedEvent
              org.eclipse.swt.events.KeyEvent

Direct Known Subclasses:
  TraverseEvent, VerifyEvent

    public class KeyEvent

extends TypedEvent

Instances of this class are sent as a result of keys being pressed and released on the keyboard.

When a key listener is added to a control, the control will take part in widget traversal. By default, all traversal keys (such as the tab key and so on) are delivered to the control. In order for a control to take part in traversal, it should listen for traversal events. Otherwise, the user can traverse into a control but not out. Note that native controls such as table and tree implement key traversal in the operating system. It is not necessary to add traversal listeners for these controls, unless you want to override the default traversal.

IMPORTANT: All `public static` members of this class are not part of the RWT public API. They are marked public only so that they can be shared within the packages provided by RWT. They should never be accessed from application code.

Since:
  1.2
See Also:
  `KeyListener`, `TraverseListener`

Field Summary
`char` `character` the character represented by the key that was typed.
`boolean` `doit` A flag indicating whether the operation should be allowed.
`static int` `KEY_PRESSED`
`static int` `KEY_RELEASED`
`int` `keyCode` the key code of the key that was typed, as defined by the key code constants in class `SWT`.
`int` `stateMask` the state of the keyboard modifier keys at the time the event was generated, as defined by the key code constants in class `SWT`.

Fields inherited from class org.eclipse.swt.events.TypedEvent
`data, display, widget`

Constructor Summary
`KeyEvent(Control source, int id)`
`KeyEvent(Event event)` Constructs a new instance of this class based on the information in the given untyped event.

Method Summary
`static void` `addListener(Adaptable adaptable, KeyListener listener)`
`protected boolean` `allowProcessing()`
`protected void` `dispatchToObserver(java.lang.Object listener)`
`protected java.lang.Class` `getListenerType()`
`static boolean` `hasListener(Adaptable adaptable)`
`static void` `removeListener(Adaptable adaptable, KeyListener listener)`
`java.lang.String` `toString()` Returns a string containing a concise, human-readable description of the receiver.

Methods inherited from class org.eclipse.swt.events.TypedEvent
`executeNext, getSource, processEvent`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### KEY_PRESSED

    public static final int KEY_PRESSED

See Also:
  Constant Field Values

### KEY_RELEASED

    public static final int KEY_RELEASED

See Also:
  Constant Field Values

### character

    public char character

  the character represented by the key that was typed. This is the final character that results after all modifiers have been applied. For example, when the user types Ctrl+A, the character value is 0x01. It is important that applications do not attempt to modify the character value based on a stateMask (such as SWT.CTRL) or the resulting character will not be correct.

### keyCode

    public int keyCode

  the key code of the key that was typed, as defined by the key code constants in class `SWT`. When the character field of the event is ambiguous, this field contains the unicode value of the original character. For example, typing Ctrl+M or Return both result in the character '\r' but the keyCode field will also contain '\r' when Return was typed.

  See Also:
    `SWT`

### stateMask

    public int stateMask

  the state of the keyboard modifier keys at the time the event was generated, as defined by the key code constants in class `SWT`.

  See Also:
    `SWT`

### doit

    public boolean doit

  A flag indicating whether the operation should be allowed. Setting this field to `false` will cancel the operation.

Constructor Detail

### KeyEvent

    public KeyEvent(Event event)

  Constructs a new instance of this class based on the information in the given untyped event.

  Parameters:
    `event` - the untyped event containing the information

### KeyEvent

    public KeyEvent(Control source,
                    int id)

Method Detail

### dispatchToObserver

    protected void dispatchToObserver(java.lang.Object listener)

  Overrides:
    `dispatchToObserver` in class `TypedEvent`

### getListenerType

    protected java.lang.Class getListenerType()

  Overrides:
    `getListenerType` in class `TypedEvent`

### allowProcessing

    protected boolean allowProcessing()

  Overrides:
    `allowProcessing` in class `TypedEvent`

### toString

    public java.lang.String toString()

  Returns a string containing a concise, human-readable description of the receiver.

  Overrides:
    `toString` in class `TypedEvent`
  Returns:
    a string representation of the event

### addListener

    public static void addListener(Adaptable adaptable,
                                   KeyListener listener)

### removeListener

    public static void removeListener(Adaptable adaptable,
                                      KeyListener listener)

### hasListener

    public static boolean hasListener(Adaptable adaptable)

Eclipse Rich Ajax Platform

Copyright (c) EclipseSource and others 2002, 2012. All rights reserved.